export interface Dependencies {
	[key: string]: string
}
export interface Imports {
	[key: string]: [RegExpMatchArray, Error | string]
}
export interface Files {
	[path: string]: Error | string
}
export interface ConvertOpts {
	path: string
	cache: Files
	nm: string
	deps: Dependencies
	devDeps: Dependencies
}
export declare function convert(opts: ConvertOpts): Promise<Error | string>
export interface MakeOpts {
	/** The package directory that we will be making a deno edition for */
	cwd?: string
	/** If the entry is incompatible, then fail */
	failOnEntryIncompatibility?: boolean
	/** If any test module is incompatible, then fail */
	failOnTestIncompatibility?: boolean
	/**
	 * If any other module is incompatible, then fail.
	 * This excludes entry, which is governed by {@link failOnEntryIncompatibility}
	 * This excludes tests, which are governed by {@link failOnTestIncompatibility}
	 */
	failOnOtherIncompatibility?: boolean
}
export declare function make({
	cwd,
	failOnEntryIncompatibility,
	failOnTestIncompatibility,
	failOnOtherIncompatibility,
}?: MakeOpts): Promise<boolean>
//# sourceMappingURL=index.d.ts.map
